		
	-- Menu Stuff ------------

	menu={}
	
function menu.load()
	
	--menu.options={'1','2','3','4','5'} -- menu options
	
	menu.options={'A','B','C','D','E'}
	menu.colors={
		{100,0,0},
		{0,100,0},
		{0,0,100},
		{100,100,0},
		{0,0,0}
		}
	menu.option=5 --current option
	menu.position=menu.option --option displayed on menu
	menu.move=false
	menu.counter=0
	menu.state='on'
	menu.selectRight='pagedown'
	menu.selectLeft='pageup'
	menu.select=nil--'return'
	
	--functions
	
	function menu:drawOption(x,y,xi,yi,i)
		
		love.graphics.setLineStyle('rough')
	
		local w=30 --dimensions of rectangles
		local h=20
		local c=self.colors[i]
		
		--love.graphics.setColor(255,255,255)
		--love.graphics.line(x,y,xi,yi) --line from center to selection
		
		--love.graphics.setColor(55,155,55)
		love.graphics.setColor(c[1],c[2],c[3])
		love.graphics.rectangle('fill',xi-w/2,yi-h/2,w,h)

		love.graphics.setColor(255,255,255)		
		love.graphics.rectangle('line',xi-w/2,yi-h/2,w,h) 
		love.graphics.print(self.options[i],xi-5,yi-5) -- selection text		
	end
	
	
	function menu:display(x,y,front)
	
		local s=self.options
		if self.option>#s then self.option=#s end	--to stop errors during testing
		
		
		local p=self.position	--the current position of the menu.  Needs to be set to the option (done in animate())
		
		--drawing details
		local r=20 --80--radius of circle
		local a=90-360/#s*(self.position-1) --adjustment
		
		local sy=0.3--vertical stretch
		local sx=2--horizontal stretch
		local d=10 --icon dip
		
		for i,v in ipairs(s) do
			
			local xi=x+r*math.cos(math.rad(360/#s*(i-1)+a))*sx
			local yi=y+r*math.sin(math.rad(360/#s*(i-1)+a))*sy
			
			if front==nil then
			
				menu:drawOption(x,y,xi,yi,i)
			
			elseif front=='front' and yi>=y then
			
				menu:drawOption(x,y,xi,yi,i)
				
			elseif front=='back' and yi<=y then 
			
				menu:drawOption(x,y,xi,yi,i)

			end
			
		end
		--]]
	end	
	
	function menu:animate(dt)
		
		if self.move then --self.move triggered under key press
		--if self.counter>0 then		
			
			local f=3 --speed factor
			
			if self.counter-dt*f>=0 then --starts off as 1
			
				self.counter=self.counter-dt*f -- counts down
				
				if menu.move=='right' then
					self.position=self.position-dt*f
					
				elseif menu.move=='left' then
					self.position=self.position+dt*f
				end				 

			else self.counter=0 
				self.position=self.option 
				self.move=nil
				
			end
					
		end

	end
	
	
	function menu:press(key)
	
		local ls=self.selectLeft
		local rs=self.selectRight
		local s=self.select
		
		if menu.state=='off' then 
			
			if key==s then menu.state='activate' end
		
		elseif menu.state=='on' then
		
			local o=self.option
			local s=#self.options
			
			if key==s then menu.state='deactivate'
			
			else
				--self.counter is a timer that will count down
				if key==rs or key==ls then self.counter=self.counter+1 end
		
				--change menu.option
				if key==rs then o=o-1 menu.move='right'
				elseif key==ls then o=o+1  menu.move='left'end
		
				if o>s then o=1
				elseif o<1 then o=s end
		
				self.option=o
			end
		end
	
	end
	
end	
	