require ('grid')
require ('pointer')


box={}


function box.load()

	boxList={} -- all shapes that have been drawn
	box.addNew=nil  -- is a new box currently being drawn?
	
	box.new={} -- box currently being drawn; is reused
	
		function boxList:fixUserTriangles()
	--measure in case user inputed triangles don't have the right triangle as the third point in the polygon.
	--fix triangle coordiantes just once, in love.load()

	
		for i,v in ipairs(self) do	
			if v[6] and v[10]==nil then

				local x1,y1=v[1],v[2]
				local x2,y2=v[3],v[4]
				local x3,y3=v[5],v[6]
				
					if x1~=x2 and y1~=y2 then
						--third point is right angle, no change needed
					
					elseif x1~=x3 and y1~=y3 then
						--x2,y2 is the right angle
						v[5]=x2
						v[6]=y2
						v[3]=x3
						v[4]=y3
					
					elseif x2~=x3 and y2~=y3 then
						--x1,y1 is the right angle
						v[5]=x1
						v[6]=y1
						v[1]=x3
						v[2]=y3				
					end				
			
			end
		end
	end	
	

	function box:drawOne(style)
	-- used to draw each shape in boxList
	--color will be handled in drawAll
	
		-- put in default settings
		if style~='fill' and style~='line' then style='line' end
		
		--triangles will be drawn differently from boxes.
		--if self[6] then
		if #self==10 then
		
			--triangles seem pretty easy to draw right now.  
			love.graphics.polygon(style,
				self[1], self[2],
				self[3], self[4],
				self[5], self[6]
			)
			
		--[[Adding a new shape: parallelogram
		
		--]]
		elseif #self==16 then--self[14] then
		
			love.graphics.polygon(style,
				self[1], self[2],
				self[3], self[4],
				self[5], self[6],
				self[7], self[8]
			)

--[[FOR DEBUGGING
			local yleft=self[self[13]]--[[
			local slope=self[14]
			local xmin=self[self[9]]--[[
			local xadj=self[15]
			local yadj=self[16]
			
			--not always half way but good enough
			local x=love.mouse.getX()
			--+math.abs((self[3]-self[5])/2)
			
			x=x--xmin
			
			local yUp=yleft+slope*(x-xadj)
			local yDown=yleft+slope*(x-xadj)+yadj

			love.graphics.setColor(10,100,255)
			love.graphics.line(x,yUp,x,yDown)		
			love.graphics.print('up '..self[15],x,yUp)
			love.graphics.print('down '..self[16],x,yDown)

--END DEBUGGING SEGMENT--]]

			
		elseif #self==4 then--box={x,y,width,height}
		love.graphics.rectangle(style,self[1],self[2],self[3],self[4])
		
		else --test for errors
			love.graphics.setColor(255,255,255)
			love.graphics.print(#self,100,100)
		
		end
		
	end

	function box.drawAll(box,shapeList)
		for i,v in ipairs(shapeList) do
			local s=#shapeList
			if s>0 then
				for i=1,s do
					box:drawList(shapeList[i])
				end
			
			end
		end
	
	end
	
	function box.color(boxList,adj,trans)
	--If a category of shapes has a color field, then this function will set the color to that color, with some adjustments.
	
	if adj==nil then adj=0 end
	if trans==nil then trans=255 end
	
		if boxList.color then
			local c=boxList.color
			local a=adj
			love.graphics.setColor(c[1]+a,c[2]+a,c[3]+a,trans)
			else
			love.graphics.setColor(255,255,255,trans)
		end		
	
	end
	
	function box.drawList(box,boxList)	
		if #boxList==0 then 
			--pointer.tip='left click to draw .............. Del key clears all'
		end
	
		local x, y = love.mouse.getPosition( )	

		--actively draw box; dragging method
		
		if love.mouse.isDown('l') and box.addNew then
			love.graphics.setColor(255,255,255,100)
			love.graphics.setLineStyle('rough')
			love.graphics.rectangle(
				'line',
				box.new[1],
				box.new[2],
				x-box.new[1],
				y-box.new[2]
			)
		end
		
		--draw old boxes
		--test for highlighting is done here.
		
		for i,v in ipairs(boxList) do
			
			box.color(boxList,40,255)
			love.graphics.setLineStyle('rough')
			--love.graphics.setLine(3)
			box.drawOne(v,'line')
			
			box.color(boxList,40,100)
			--love.graphics.setColor(255,255,255,25)
			
			box.drawOne(v,'fill') 
			
			--highlight if applicable
			if box.click(v) then
				v.highlight=true
				else v.highlight=nil
			end
		
		love.graphics.setLineStyle('smooth')
		
		--I have the option of changing how shapes look when interacted with
		if v.move then 
			
			--box.color(boxList,40,255)
			love.graphics.setColor(255,255,255)
			love.graphics.setLineStyle('smooth')
			love.graphics.setLineWidth(1)
			box.drawOne(v,'line')
			
			--pointer.tip='drag to move'
			
		elseif v.highlight then 
		
			--love.graphics.setColor(255,255,255,50)
			--love.graphics.setColor(200,0,255,100)
			--love.graphics.setColor(255,100,255,150)
			
			box.color(boxList,70,100)
			
			--love.graphics.setColor(255,255,255)
			love.graphics.setLineWidth(1)
			box.drawOne(v,'fill')
			
			--pointer.tip='Left click to move ............. Right click to delete'
			
		else love.graphics.setLineWidth(1)
			--pointer.tip='left click to draw .............. Del key clears all'
		end		


		end
		
		--actively draw shape; point by point method.
		
		if box.pointByPoint then
			love.graphics.setColor(255,255,255,50)
			love.graphics.setLineStyle('rough')			
			--[[
			box.new[1], box.new[2] are the first set of coordinates;
			[3] and [4] need to be the next set of coordinates;
			[5] and [6] need to be the last set of coordinates.
			
			x,y are the current coordiantes.

			if the first line is vertical or horizontal, then the third click will establish the height or depth of the drawn box.
			
			if the second click is diagonal to the first point, then a 3 sided polygon should be being drawn.
			--]]
			
			
			--make sure point 1 and point 2 aren't the same
			if box.new[1]==box.new[3] and box.new[2]==box.new[4] then
				--untested(or untestable?)
				table.remove(box.new,4)
				table.remove(box.new,3)
			
			--if vertical line
			elseif box.new[1]==box.new[3] then 


			
				--love.graphics.setColor(255,255,255,20)
				love.graphics.rectangle(
					'line',
					box.new[1],
					box.new[2],
					x-box.new[1],
					box.new[4]-box.new[2]
				)
				
				local p=box.new
				--love.graphics.setColor(255,255,255,50)
				love.graphics.polygon(
					'line',
					p[1],p[2],
					p[3],p[4],
					x,y,
					x+p[1]-p[3],
					y+p[2]-p[4]				
				)
				
				
			--if horizontal line
			elseif box.new[2]==box.new[4] then
				
				--love.graphics.setColor(255,255,255,10)
				love.graphics.rectangle(
					'line',
					box.new[1],
					box.new[2],
					box.new[3]-box.new[1],
					y-box.new[2]	
					)

				local p=box.new
				--love.graphics.setColor(255,255,255,50)
				love.graphics.polygon(
					'line',
					p[1],p[2],
					p[3],p[4],
					x,y,
					x+p[1]-p[3],
					y+p[2]-p[4]				
				)
					
			--if only one point drawn
			elseif #box.new==2 then
			-- just draw a line
			
				love.graphics.line(
					box.new[1],
					box.new[2],
					x,
					y
				)
			
			--otherwise you're drawing a right triangle.  The location of the right angle will be above or below the diagonal, depending on the current positionof the mouse.
			else
			
				box.new.triangle=true
				
				local rise=box.new[2]-box.new[4]
				local run=box.new[3]-box.new[1]
				
				local belowPoint=nil
				local abovePoint=nil
				
				if box.new[1] < box.new[3] and box.new[2] < box.new[4] then
					belowPoint={box.new[1],box.new[4]}
					abovePoint={box.new[3],box.new[2]}
				
				elseif box.new[1] < box.new[3] and box.new[2] > box.new[4] then
					belowPoint={box.new[3],box.new[2]}
					abovePoint={box.new[1],box.new[4]}

				elseif box.new[1] > box.new[3] and box.new[2] < box.new[4] then
					belowPoint={box.new[1],box.new[4]}
					abovePoint={box.new[3],box.new[2]}
					
				elseif box.new[1] > box.new[3] and box.new[2] > box.new[4] then
					belowPoint={box.new[3],box.new[2]}
					abovePoint={box.new[1],box.new[4]}					
					
				end
				
				if y > box.new[2]-(x-box.new[1])*rise/run then	
				--if point below diagonal
				
				box.new[5]=belowPoint[1]
				box.new[6]=belowPoint[2]
			
				love.graphics.polygon(
					'line',
					box.new[1],
					box.new[2],
					box.new[3],
					box.new[4],
					box.new[5],
					box.new[6]
					
					
				)
				
				else --if point above diagonal
				
				box.new[5]=abovePoint[1]
				box.new[6]=abovePoint[2]				
				
				love.graphics.polygon(
					'line',
					box.new[1],
					box.new[2],
					box.new[3],
					box.new[4],
					box.new[5],
					box.new[6]
				)				
				end
			end
		
			--]]
		end
		
	end		
	
	
	function box:click()
		--is mouse over box?
		x,y = love.mouse.getPosition( )
			
		if #self==4 then
			return x>self[1] and x<self[1]+self[3] and y>self[2] and y<self[2]+self[4]
		end
		
		if #self==6 then --manually written triangle that may not have extra variables. This should work as long as right angle is at the third point, self[5],self[6]. It's messy because it's based on my first attempt at triangles.

			--I know I've used min and max inconsistently
			local ymax=math.max(self[2],self[4])
			local ymin=math.min(self[2],self[4])
			local xmax=math.max(self[1],self[3])
			local xmin=math.min(self[1],self[3])
			local slope=(ymax-ymin)/(xmax-xmin)
			local yleft=nil
			if self[1]==xmin then 
				yleft=self[2] else yleft=self[4] 
			end
			
			
			
			if self[6]==math.min(self[2],self[4]) then
			-- right angle above
			
				if self[5]==math.min(self[1],self[3]) then
				--right angle to the right
					return y<yleft-(x-xmin)*slope
					
				else-- right angle to the left
					return y<yleft+(x-xmin)*slope
				
				end
			
			else --right angle below
			
				if self[5]==math.min(self[1],self[3]) then
				--right angle to the right
					return y>yleft+(x-xmin)*slope
				
				else-- right angle to the left
					return y>yleft-(x-xmin)*slope
				end			
			end		
		
		
		end
		
		if #self==10 then --triangle
			
			-- if collide with rectangle
			
			--note: I could increase the size of triangle lists to 14 and store xmin, ymin, xmax, and ymax.  That wouldn't conflict with parallelograms which also would have xadj and yadj values. But if I make that change, then I have to go around and change a lot of "==10"s to "==14".
			
			if 	x> math.min(self[1],self[3],self[5]) and	-- left
				x< math.max(self[1],self[3],self[5]) and	-- right
				y> math.min(self[2],self[4],self[6]) and	-- top
				y< math.max(self[2],self[4],self[6]) 		-- bottom
			
			then 
				--[[ 
				Right angle is always the third point
				options:	|/-/|	|\-\|		
				goal:
					calculate slope
					detect mouse whether above or below slope
					
					y = mx+b
					  = (rise/run)

				--]]

				--New Method
				--if #self==10 then --triangle
					local diagonal=self[self[7]]+self[10]*(x-self[self[8]])
					
					if self[6]==self[self[9]] then --right angle above
						return y<diagonal
					else
						return y>diagonal
					end
				--]]
				--else
				
				--old method needs to be put under a different if function to work. Namely, if #self==6
				--[[ Old method
					

				--]]
				--end

			end

		end
	
		if #self==16 then
			
			if
				x>self[self[9]] and
				y>self[self[10]] and
				x<self[self[11]] and
				y<self[self[12]]
			then
				local yleft=self[self[13]]
				local slope=self[14]
				local xmin=self[self[9]]
				local xadj=self[15]
				local yadj=self[16]
				
				local yUp=yleft+slope*(x-xadj)
				local yDown=(yleft+yadj)+slope*(x-xadj)
				
				--works with verticals
				return y>yUp and y<yDown
				--
				--return y<yUp and y>yDown
			end
		
		end
	end
	
	--not needed
	function box.updateAll(box,shapeList)

		local s=#shapeList
		if s>0 then
			for i=1,s do
				box:update(shapeList[i])
			end
		
		end	
	
	end	
	
	function box.update(box,boxList)
		--this keeps track of where you move shapes
	
		for i,v in ipairs(boxList) do
		
			if v.move then --( important not to include.vhightlight, because often mouse will move off snapping shapes when dragging them)
			
				local x,y=love.mouse.getPosition( )
				
				if love.mouse.isDown( 'l' ) then
					--move shape
					
					if #v==16 then

						local a3=v[1]-v[3] -- x1-x2
						local a4=v[2]-v[4] -- y1-y2
						local a5=v[1]-v[5] -- x1-x3
						local a6=v[2]-v[6] -- y1-y3
						
						v[1],v[2]=grid:snapTo(x+v.adjx, y+v.adjy)
						v[3]=v[1]-a3
						v[4]=v[2]-a4
						v[5]=v[1]-a5
						v[6]=v[2]-a6
						v[7]=v[5]+v[1]-v[3]
						v[8]=v[6]+v[2]-v[4]		

						
						if v[14]<0 then
						v[15]=v[v[9]]--+math.abs(v[1]-v[3])
						else
						v[15]=v[v[9]]+math.abs(v[1]-v[3])
						end
						
						
					
					elseif #v==10 or #v==6 then --if triangle
						--[[
						1) record relative positions of points 2 and 3 to point 1, 
						2) move point 1
						3) move other points based on relative position to point 1
						
						given v[1] and v[2], need to be able to define other coordinates according to it.
						v[3],v[5]
						v[4],v[6]
						
						--]]
						local a3=v[1]-v[3] -- x1-x2
						local a4=v[2]-v[4] -- y1-y2
						local a5=v[1]-v[5] -- x1-x3
						local a6=v[2]-v[6] -- y1-y3
						
						v[1],v[2]=grid:snapTo(x+v.adjx, y+v.adjy)
						v[3]=v[1]-a3
						v[4]=v[2]-a4
						v[5]=v[1]-a5
						v[6]=v[2]-a6
					
					--
					else v[1],v[2]=grid:snapTo(x+v.adjx, y+v.adjy)
				
					end	
				end
			end
		end
	end	
	
	--This WILL NOT word, but that's ok because I don't need it anyway
	function box.mousePressAll(box,shapeList,x,y,button)
		for i,v in ipairs(shapeList) do
			local s=#shapeList
			if s>0 then
				for i=1,s do
					box.mousepressed(box,shapeList[i],x,y,button)
				end
			
			end
		end
	
	end	
	
	function box.mousepressed(box,boxList,x,y,button)
	
		--delete with right click
		if button=='r' then
		
			for i,v in ipairs(boxList) do
				if box.click(v) then
					table.remove(boxList,i)
				end
			
			end
		
		end
		
		--Many left click functions.	
		
		--if point by point is engaged, then that takes priority. Otherwise, users will be able to move shapes, and start drawing new shapes.
		if button=='l' then
			
			if box.pointByPoint then
				--[[Okay, I'm adding an all new shape to the pointByPoint method.  I'm changing the rectangle drawing procedure into a parallelogram drawing procedure.
				--]]
			
				--if only first click has been made, register second click
				if #box.new==2 then 
					box.new[3], box.new[4]= grid:snapTo(x,y)
					
	
				--if second click was not diagonal, then we're drawing a rectangle, and this third click will complete it.  That shape will then be added to the boxList.
				
				--Update: Allow users to establish a parallelogram instead of a rectangle.
				
				--[[For a parallelogram.
				
				index	variable
				1	x1
				2	y1
				3	x2
				4	y2
				5	x3
				6	y3
				7	x4
				8	y4
				9	xmin	--index, not value
				10	ymin	--index, not value
				11	xmax	--index, not value
				12	ymax	--index, not value
				13	yleft	--index, not value
						
				14	slope
						(y3-y2)/(x3-x2)
				15	xadj	--constant
							=xmin+extra horizontal shift if needed
					Actually, I'm going to have to retool xadj and yadj.  xadj will relpace xmin to yield the following equaiton: y=yleft+m*(x-xadj). It will apply to both the yUp and yDown tests
						
				16	yadj	--constant
					yadj will only apply to the yDown test.  In the vertical case, it will be calculated as normal. In the horizontal case, yadj=-slope*(xmin+math.abs(p[1]-p[3]))
				
				--]]
				elseif #box.new==4 then --register third click
				
					box.new[5], box.new[6]= grid:snapTo(x,y)
					
					local newbox={}
					
					--if x1==x2
					if box.new[1]==box.new[3] then
					-- first line was vertical
					
						--if y2==y3
						if box.new[4]==box.new[6] then
						--test that shape is a rectangle
						
							--upper left x
							newbox[1]=math.min(box.new[1],box.new[5])
							--upper left y
							newbox[2]=math.min(box.new[2],box.new[4])
							--width
							newbox[3]=math.abs(box.new[1]-box.new[5])
							--height
							newbox[4]=math.abs(box.new[2]-box.new[4])
						
						--first line vertical
							--p[15]=xadj=xmin=constant??? No, the xmin changes if you move the shape. Need to then include this change in update function
							--p[16]=yadj=abs(y2-y1)=constant.
						else--shape is a parallelogram
							
							local p=box.new
							
							newbox[1]=p[1]
							newbox[2]=p[2]
							newbox[3]=p[3]
							newbox[4]=p[4]
							newbox[5]=p[5]
							newbox[6]=p[6]
							
							p[7]=p[5]+p[1]-p[3]
							p[8]=p[6]+p[2]-p[4]
							
							newbox[8]=p[8]
							newbox[7]=p[7]
							
							--thre are no coordinate values after this point, just maybe indices to what's come before
							local xmin=math.min(p[1],p[3],p[5],p[7])
							local ymin=math.min(p[2],p[4],p[6],p[8])
							local xmax=math.max(p[1],p[3],p[5],p[7])
							local ymax=math.max(p[2],p[4],p[6],p[8])
							
							if xmin==p[1] then p[9]=1
							elseif xmin==p[3] then p[9]=3
							elseif xmin==p[5] then p[9]=5
							elseif xmin==p[7] then p[9]=7							
							end

							if ymin==p[2] then p[10]=2
							elseif ymin==p[4] then p[10]=4
							elseif ymin==p[6] then p[10]=6
							elseif ymin==p[8] then p[10]=8							
							end

							if xmax==p[1] then p[11]=1
							elseif xmax==p[3] then p[11]=3
							elseif xmax==p[5] then p[11]=5
							elseif xmax==p[7] then p[11]=7
							end

							if ymax==p[2] then p[12]=2
							elseif ymax==p[4] then p[12]=4
							elseif ymax==p[6] then p[12]=6
							elseif ymax==p[8] then p[12]=8							
							end							
							
							newbox[9]=p[9]
							newbox[10]=p[10]
							newbox[11]=p[11]
							newbox[12]=p[12]
							
							--when first line is vertical, the xleft/xmin will ether be x1/2 or x3/4
							--the higher (so lower value) y coordinate will then by yleft
							
							--yleft
							if xmin==p[1] then
							
								if p[2] < p[4] then
									newbox[13]=2--p[2]
								else
									newbox[13]=4--p[4]
								end
							
							elseif xmin==p[5] then
							
								if p[6] < p[8] then
									newbox[13]=6--p[6]
								else
									newbox[13]=8--p[8]
								end
							end
							
							
							--slope
							newbox[14]= (p[6]-p[4])/(p[5]-p[3])
							
							newbox[15]= p[p[9]]--xadj=xmin
							newbox[16]= math.abs(p[2]-p[4])--yadj
	
							
						end

					--if y1==y2
					--xadj=xmin+abs(x2-x1)
					--yadj=slope*(-abs(x2-x1))
					elseif box.new[2]==box.new[4] then
					--first line was horizontal
					
						--if x2==x3
						if box.new[3]==box.new[5] then
						--test that shape is a rectangle
						
							--upper left x
							newbox[1]=math.min(box.new[1],box.new[3])
							--upper left y
							newbox[2]=math.min(box.new[2],box.new[6])
							--width
							newbox[3]=math.abs(box.new[1]-box.new[3])
							--height
							newbox[4]=math.abs(box.new[2]-box.new[6])
							
						--first line horizontal
						else--shape is a parallelogram
							local p=box.new	
							
							newbox[1]=p[1]
							newbox[2]=p[2]
							newbox[3]=p[3]
							newbox[4]=p[4]
							newbox[5]=p[5]
							newbox[6]=p[6]
							
						
							p[7]=p[5]+p[1]-p[3]
							p[8]=p[6]+p[2]-p[4]
							
							newbox[8]=p[8]
							newbox[7]=p[7]
							
							--thre are no coordinate values after this point, just maybe indices to what's come before
							local xmin=math.min(p[1],p[3],p[5],p[7])
							local ymin=math.min(p[2],p[4],p[6],p[8])
							local xmax=math.max(p[1],p[3],p[5],p[7])
							local ymax=math.max(p[2],p[4],p[6],p[8])
							
							if xmin==p[1] then p[9]=1
							elseif xmin==p[3] then p[9]=3
							elseif xmin==p[5] then p[9]=5
							elseif xmin==p[7] then p[9]=7							
							end

							if ymin==p[2] then p[10]=2
							elseif ymin==p[4] then p[10]=4
							elseif ymin==p[6] then p[10]=6
							elseif ymin==p[8] then p[10]=8							
							end

							if xmax==p[1] then p[11]=1
							elseif xmax==p[3] then p[11]=3
							elseif xmax==p[5] then p[11]=5
							elseif xmax==p[7] then p[11]=7
							end

							if ymax==p[2] then p[12]=2
							elseif ymax==p[4] then p[12]=4
							elseif ymax==p[6] then p[12]=6
							elseif ymax==p[8] then p[12]=8							
							end		
							
							newbox[9]=p[9]
							newbox[10]=p[10]
							newbox[11]=p[11]
							newbox[12]=p[12]
							
							--when first line is horizontal, the xleft/xmin could be anything. But whatever point is the leftmost x value, the corresponding y value will definitely be yleft.
							
							--NO, that was a mistake.  If the slope is negative, then things will be different
							
							--slope
							newbox[14]= (p[6]-p[4])/(p[5]-p[3])
							local slope=newbox[14]
							
							--horizontal
							if slope<0 then

								if xmin==p[1] then
									newbox[13]=2--p[2]
								elseif xmin==p[3] then
									newbox[13]=4--p[4]
								elseif xmin==p[5] then
									newbox[13]=6--p[6]	
								elseif xmin==p[7] then			
									newbox[13]=8--p[8]
								end

								newbox[15]= p[p[9]]--xmin--math.abs(p[1]-p[3])--xadj
								newbox[16]= -slope*(math.abs(p[1]-p[3]))--yadj
							--horizontal
							elseif slope>0 then
								---[[ new
								
								if xmin==p[1] then --x1
									newbox[13]=4--y2
								elseif xmin==p[3] then --x2
									newbox[13]=2--y1
								elseif xmin==p[5] then --x3
									newbox[13]=8--y4	
								elseif xmin==p[7] then	--x4	
									newbox[13]=6--y3
								end

								newbox[15]= p[p[9]]+math.abs(p[1]-p[3])--xadj
								newbox[16]= slope*(math.abs(p[1]-p[3]))--yadj
								--]]
							
							--[[old
								if xmin==p[1] then
									newbox[13]=2--p[2]
								elseif xmin==p[3] then
									newbox[13]=4--p[4]
								elseif xmin==p[5] then
									newbox[13]=6--p[6]	
								elseif xmin==p[7] then			
									newbox[13]=8--p[8]
								end

								newbox[15]= math.abs(p[1]-p[3])--xadj
								newbox[16]= math.abs(p[2]-p[4])--yadj							
							--]]
								
							end
						end

					end
					
					--add box or parallelogram to boxList
					
					if box.new[2]==box.new[4] and box.new[2]~=box.new[6] then table.insert(boxList,newbox)
					elseif box.new[1]==box.new[3] and box.new[1]~=box.new[5] then table.insert(boxList,newbox)
					end
					
					box.pointByPoint=nil
					
					--end
				
				--If there are already 3 points established, that means we're dealing with a triangle (the third point would have been automatically generated once the first line was a diagonal). This last click will determine if the right angle is above the diagonal, or below it. Once that's determined, the shape will be added to the boxList.
				
				elseif #box.new==6 then
				
					local b=box.new
					
					-- 
					local ymax=nil
					--math.min(box.new[2],box.new[4])
					if box.new[2]<box.new[4] then ymax=2
					else ymax=4 end
					
					--
					local xmin=nil--math.min(box.new[1],box.new[3])
					if b[1]<b[3] then xmin=1
					else xmin=3 end
					
					--b of y=mx+b
					local yleft=nil
					if box.new[1] < box.new[3] then
						yleft=2
					else
						yleft=4
					end
					
					--find m of y=mx+b; slope
					local rise=math.max(b[2],b[4],b[6])-math.min(b[2],b[4],b[6])
					local run=math.max(b[1],b[3],b[5])-math.min(b[1],b[3],b[5])
					local m=rise/run
					
					--Tested and confirmed to work
					
					if b[6]==b[ymax] then
						--right angle at top
						if b[5]==math.min(b[1],b[3]) then
							-- \|
							m=-m
						else -- |/
							m=m
						end
					else --right angle below
						if b[5]==math.min(b[1],b[3]) then
							--|\
							m=m
						else -- /|
							m=-m
						end					
					end
				
				
					local newtriangle={
					box.new[1], --x1
					box.new[2], --y1
					box.new[3], --x2
					box.new[4], --y2
					box.new[5], --x3
					box.new[6],	--y3
					yleft,	-- 7
					xmin,	-- 8
					ymax,	-- 9
					m, -- slope; 10
					}
					
					--add triangle to boxList
					table.insert(boxList,newtriangle)
					box.pointByPoint=nil
					
				
				else --ready to finish pointByPoint method
				
				box.pointByPoint=nil
				
				end
				
			--]]	
			else
			
			--if point by point method is not engaged, then players will be able to move shapes.  They will also be able to start drawing new shapes.
			
			--If I add more types of boxLists, though, the following function will not work.  I'll have to repeat it for every type of boxList.  
			local clicked=nil
				for i,v in ipairs(boxList) do
					if box.click(v) then
						v.move=true
						v.adjx=v[1]-x
						v.adjy=v[2]-y
						clicked=true
					end
				end
			
			local x, y = grid:snapTo(x,y)
			
			--Don't make a new box unless you click an empty space.
			if clicked then box.addNew=false
			else
				box.addNew=true box.new={x,y}
			end
		end
		
	end
	end

	
	
	--This WILL NOT word, but that's ok because I don't need it anyway
	function box.mouseReleaseAll(box,shapeList,x,y,button)
		for i,v in ipairs(shapeList) do
			local s=#shapeList
			if s>0 then
				for i=1,s do
					box.mousereleased(box,shapeList[i],x,y,button)
				end
			
			end
		end
	
	end		
	
	function box.mousereleased(box, boxList, x,y,button)
		local x, y = grid:snapTo(x,y)
		
		for i,v in ipairs(boxList) do
			v.move=nil end	
			
		if button=='l' and box.addNew then
			box.addNew=nil -- bad idea
			
			--if box dimensions are both greater than one unit, then add a new box to the boxList. Otherwise, start point-by-point method
			if math.abs(box.new[1]-x) ~=0 and math.abs(box.new[2]-y)~=0 then
			
				local newbox={}
				
				if x>box.new[1] then
					newbox[1]=box.new[1]
					newbox[3]=x-box.new[1]
				else 
					newbox[1]=x
					newbox[3]=box.new[1]-x
				end		
				if y>box.new[2] then
					newbox[2]=box.new[2]		
					newbox[4]=y-box.new[2]
				else
					newbox[2]=y
					newbox[4]=box.new[2]-y
				end	

				--add box to boxList
				table.insert(boxList,newbox)
			
			--[[
			
			
			otherwise, start point-by-point drawing method. box.new[1] and box.new[2] already contain the fist point.
			Also, the actively drawn box needs to be done differently.
			
			x,y are the current coordiantes
			box.new[1], box.new[2] are the previous set of coordinates
			--]]
			
			else box.pointByPoint=true	
			-- when using poiniByPoint, the new shape is added at mousePressed rather than mouseReleased
			
			end
		end
	end		

	
end
