require ('boxDrawer')
require ('pointer')
require ('ZXmenu')
require ('savefunctions')
require ('classic menu')

function love.load()

	--adding classic menu
	m:load()

	--load functions
	box.load() --contains box and boxList
	grid.load()
	pointer.load()
	menu.load()
	
	------
	---[[

	listA={
			name='red',
			color={100,0,0}
			}
	listB={
			name='green',
			color={0,100,0}
			}
	listC={
			name='blue',
			color={0,0,100}
			}
	listD={
			name='mustard',
			color={100,100,0}
			}

	listE={
		name='shadow',
		color={255,255,255}
		}

	starterList={
		listA,
		listB,
		listC,
		listD,
		listE
	}	
	
	shapeList={
		listA,
		listB,
		listC,
		listD,
		listE
	}
	

	-----After users add custom shapes directly via code

	boxList:fixUserTriangles()

	-- Need to add gamestate in order to cycle between normal mode and menu-mode
	gamestate=nil
	
	
end

function love.update(dt)

	box:updateAll(shapeList)

	--update editor based on menu state
	local s=#shapeList
	if s>0 then
		for i=1,s do
			if menu.option==i then
				boxList=shapeList[i]
				---[[
				if boxList.color then
				local c=boxList.color
				pointer.r=c[1]
				pointer.g=c[2]
				pointer.b=c[3]
				end--]]
				if boxList.name then
				pointer.tip=boxList.name
				else
				pointer.tip=''
				end
			end
		end
	end
	
	
	box.update(box,boxList)	
	
	menu:animate(dt)
	

	
	
	
end


function love.draw()

	grid:draw()--3,3)
	
	-- let's draw boxes
	box:drawAll(shapeList)
	
	-- draw ZX menu
	local mx,my=700,40
	love.graphics.setColor(255,255,255)
	menu:display(mx,my,'back')
		--you can draw something in between
	menu:display(mx,my,'front')		
	
	--Top of screen, menu stuff
	love.graphics.setColor(255,255,255)
	love.graphics.print(	
		'press key: (1) Instruction  (2) Save  (3) Load  ()  (0) Clear All',
		50,0)	

	love.graphics.print(	
		'pageUp <--> pageDn',
		633,0)		

	-- draw mouse above everything else
	pointer:draw()		
	
	--TAKE OUT OF FINAL VERSION
	--display some numbers
	love.graphics.print(#boxList,30,30) --display of number of shapes drawn
	love.graphics.print(#box.new,30,50) --no longer needed
	
	
	if gamestate=='menu' then 
		m:drawAll() 
	end	

end



function love.mousepressed(x,y,button)
	
	if gamestate=='menu' then 
	
	else
	
		box.mousepressed(box,boxList,x,y,button)
		
		--extra alteration to tweak mouse input for the menu
		
		if button=='wd' then
			local key='pageup'
			menu:press(key)
		elseif button=='wu' then
			local key='pagedown'
			menu:press(key)	
		end
	end
end

function love.mousereleased(x,y,button)
	if gamestate=='menu' then 
	else
		box.mousereleased(box, boxList, x,y,button)
	end
end


function love.keypressed(key)
	--change gamestates
	if key=='return' then
		if gamestate=='menu' then gamestate=nil
		elseif gamestate==nil then gamestate='menu'
		end
	end

	--react to gamestate
	if gamestate=='menu' then 
		m:keypressed(key)
	else
		if love.keyboard.isDown('backspace','delete') then table.remove(boxList,#boxList) end
		
		if key=='1' then
		
		elseif key=='2' then --save
			saveTables(shapeList)
		elseif key=='3' then --load
			loadTables(shapeList)

		--experimental	
		elseif key=='0' then --not working so well
			local s=#shapeList
			for i=1,s do
				local ss=#shapeList[i]
				for j=1,#boxList do
					table.remove(shapeList[i],ss)
				end
			end
		
		end
		
		menu:press(key)
	
	end
end