--extra stuff added for the editor prototype

local lfs=love.filesystem

	function saveTables(shapeList)
		local s=#shapeList
		for i=1,s do
			local t=writeList(shapeList[i])
			local f=shapeList[i].name..'.lua'
			success = love.filesystem.write( f, t )
		end
	end
	
	function loadTables(shapeList)
		local s=#shapeList
		for i=1,s do
			local f=shapeList[i].name..'.lua'
			if lfs.isFile(f) then
				local t=lfs.load(f)
				shapeList[i]=t()
			end
		end
	end



--The idea is take a table, and turn it into a string that can be saved in a text or lua file. When that file is loaded and then run, it will return the table.

--Note that this only works (and is only intended to work) with the special types of tables yielded by my Editor ProtoType.

function writeList(list)

	local s=#list

	local d='list={}\n'

	-- descriptors
	if list.name then d=d..'list.name="'..list.name..'"\n'end
	if list.color then d=d..'list.color={'..list.color[1]..','..list.color[2]..','..list.color[3]..'}\n'end
	if list.type then d=d..'list.type="'..list.type..'"\n'end
	
	
	-- individual shapes
	for i=1,s do
	
		d=d..writeShape(list,i)
	
	end
	
	d=d..'\nreturn list'
	
	return d

end

function writeShape(list, i)

	--list[i] is the shape
	--d is the string this will be added to. Alternatively, I might just create a new d, and let this function return d.  That would afford me more flexibility.

	local d='' --starting string
	
	local t=nil --shape type
	local s=#list[i]
	
	if s==4 then t='rectangle'
	
		d=d..'\nlist['..i..']={\t--'..t..'\n\t'
		d=d..list[i][1]..',\t--x1\n\t'
		d=d..list[i][2]..',\t--y1\n\t'		
		d=d..list[i][3]..',\t--width\n\t'
		d=d..list[i][4]..',\t--height\n\t'	

		d=d..'}\n'
	
	elseif s==10 then t='triangle'
	
		d=d..'\nlist['..i..']={\t--'..t..'\n\t'
		d=d..list[i][1]..',\t--x1\n\t'
		d=d..list[i][2]..',\t--y1\n\t'
		d=d..list[i][3]..',\t--x2\n\t'
		d=d..list[i][4]..',\t--y2\n\t'
		d=d..list[i][5]..',\t--x3\n\t'
		d=d..list[i][6]..',\t--y3\n\t'
		d=d..list[i][7]..',\t--yleft\n\t'
		d=d..list[i][8]..',\t--xmin\n\t'	
		d=d..list[i][9]..',\t--xmax\n\t'
		d=d..list[i][10]..',\t--slope\n\t'	
		
		d=d..'}\n'
		
	elseif s==16 then t='parallelogram'
	
		d=d..'\nlist['..i..']={\t--'..t..'\n\t'
		d=d..list[i][1]..',\t--x1\n\t'
		d=d..list[i][2]..',\t--y1\n\t'
		d=d..list[i][3]..',\t--x2\n\t'
		d=d..list[i][4]..',\t--y2\n\t'
		d=d..list[i][5]..',\t--x3\n\t'
		d=d..list[i][6]..',\t--y3\n\t'	
		d=d..list[i][7]..',\t--x4\n\t'
		d=d..list[i][8]..',\t--y4\n\t'			
		d=d..list[i][9]..',\t--xmin\n\t'
		d=d..list[i][10]..',\t--ymin\n\t'		
		d=d..list[i][11]..',\t--xmax\n\t'
		d=d..list[i][12]..',\t--ymax\n\t'	
		d=d..list[i][13]..',\t--yleft\n\t'
		d=d..list[i][14]..',\t--slope\n\t'		
		d=d..list[i][15]..',\t--xadj\n\t'
		d=d..list[i][16]..',\t--yadj\n\t'

		d=d..'}\n'
		
	else t='oddball' 	
		d=d..'\nlist['..i..']={\t--'..t..'\n\t'
		
		for j=i,s do
			d=d..'list['..i..']['..j..']='..list[i][j]..'\n\t'
		end
		d=d..'}\n'
	
	end
	
	return d

end